module crashtest;

import dwin.sys.win32.com.Core;
import dwin.sys.win32.com.InProcessServer;
import ag.com.tlb.shellobjects;
import dwin.sys.win32.Registry;

enum
{
DBIMF_NORMAL            = 0x0000,
DBIMF_FIXED             = 0x0001,
DBIMF_FIXEDBMP          = 0x0004,  // a fixed background bitmap (if supported)
DBIMF_VARIABLEHEIGHT    = 0x0008,
DBIMF_UNDELETEABLE      = 0x0010,
DBIMF_DEBOSSED          = 0x0020,
DBIMF_BKCOLOR           = 0x0040,
DBIMF_USECHEVRON        = 0x0080,
DBIMF_BREAK             = 0x0100,
DBIMF_ADDTOFRONT        = 0x0200,
DBIMF_TOPALIGN          = 0x0400,
DBIMF_NOGRIPPER         = 0x0800,
DBIMF_ALWAYSGRIPPER     = 0x1000,
DBIMF_NOMARGINS         = 0x2000,
}

version(build) {
	pragma(build_def, "CODE SHARED EXECUTE");
	pragma(build_def, "DATA WRITE");
	
	pragma(build_def, "EXPORTS");
    pragma(build_def, "DllRegisterServer");
    pragma(build_def, "DllUnregisterServer");
    pragma(build_def, "DllGetClassObject");
    pragma(build_def, "DllCanUnloadNow");
}

interface IObjectWithSite : IUnknown
{
	//"FC4801A3-2BA9-11CF-A229-00AA003D7352"
	static Guid IID = { 0xFC4801A3, 0x2BA9, 0x11CF, 0xa2, 0x29, 0x00, 0xaa, 0x00, 0x3d, 0x73, 0x52 };
    int SetSite(IUnknown pUnkSite);
    int GetSite(Guid riid, void **ppvSite);
}

class IEToolbar : Implements!(IDeskBand, IObjectWithSite) //Maybe IDeskBand2 later
{
	//{2EB5536C-C018-4791-BCD0-DBE9287A4A09}
	static Guid CLSID = { 0x2eb5536c, 0xc018, 0x4791, 0xbc, 0xd0, 0xdb, 0xe9, 0x28, 0x7a, 0x4a, 0x9 };
	static char[] description = "Test Toolbar";
	static char[] appname = "EGToolbar";
	static int toolbarcount;
	
	static void register()
	{
		scope clsidKey = RegistryKey.localMachine.openSubKey("SOFTWARE\\Microsoft\\Internet Explorer\\Toolbar", true);
		if (clsidKey !is null) 
		{
	        clsidKey.setValue!(char[])(CLSID.toString(), " ");
		}
	}
	
	static void unregister()
	{
		scope clsidKey = RegistryKey.localMachine.openSubKey("SOFTWARE\\Microsoft\\Internet Explorer\\Toolbar", true);
	    if (clsidKey !is null)
	    {
	        clsidKey.deleteValue(CLSID.toString());
	    }
	    RegistryKey.localMachine.deleteSubKey("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Ext\\Settings\\" ~ CLSID.toString());
	    foreach(key; RegistryKey.users)
	    {
			scope toolbarKey = key.openSubKey("SOFTWARE\\Microsoft\\Internet Explorer\\Toolbar\\WebBrowser", true);
		    if (toolbarKey !is null)
		    {
		        toolbarKey.deleteValue(CLSID.toString());
		    }
	    	
	    }
	}
	
	//IWebBrowser browser;
	HWND handle;
	IUnknown site;
	//uint connection;

	int GetBandInfo(uint dwBandID, uint dwViewMode, ref tagDESKBANDINFO pdbi)
	{
		logger.info("GetBandInfo");
		pdbi.ptMinSize.x = 640;
		pdbi.ptMinSize.y = 27;
        pdbi.ptMaxSize.x = 0;
        pdbi.ptMaxSize.y = -1;
        pdbi.ptIntegral.x = 0;
        pdbi.ptIntegral.y = 0;
        pdbi.ptActual.x = 2000;
        pdbi.ptActual.y = 27;
        //How do we handle this case
        //pdbi.wszTitle = "";
        pdbi.dwModeFlags = DBIMF_UNDELETEABLE | DBIMF_NORMAL | DBIMF_BREAK;
        pdbi.crBkgnd = 0;
		return S_OK;
	}

	private static extern(Windows) int windowProcFunc (HWND hwnd, uint msg, uint wParam, int lParam) 
	{
		return 1;
	}
	
    int SetSite(IUnknown pUnkSite)
    {
		logger.info("SetSite");
    	if(pUnkSite)
    	{
    		site = pUnkSite;
    		logger.info("Create a new Toolbar");
			
    		/*IOleWindow olewindow;
    		pUnkSite.QueryInterface(IOleWindow.IID, cast(void**)&olewindow);
			_RemotableHandle* hwndparent;
			olewindow.GetWindow(hwndparent);
			handle = hwndparent;*/
			
			//IServiceProvider provider;
			//pUnkSite.QueryInterface(IServiceProvider.IID, cast(void**)&provider);
			//provider.QueryService(IWebBrowserApp.IID, IWebBrowser.IID, cast(void**)&browser);

			logger.info("Before syncExec");
    	}
    	else
    	{
    		site = null;
    	}
		return S_OK;
    }

    int GetSite(Guid riid, void **ppvSite)
    {
		logger.info("GetSite");
		*ppvSite = cast(void*)site;
		site.AddRef();
		return S_OK;
    }
	
	int ShowDW(int fShow)
	{
		logger.info("ShowDW");
		return S_OK;
	}
	int CloseDW(uint dwReserved)
	{
		logger.info("CloseDW");
		//Display display = Display.getDefault();
		/*display.asyncExec(dgRunnable( (Display display, IEToolbar ie){
			ie.toolbar.shell.close();
		}, display, this));*/
		return S_OK;
	}
	
	int ResizeBorderDW(tagRECT* prcBorder, IUnknown punkToolbarSite, int fReserved)
	{
		logger.info("ResizeBorderDW");
		return E_NOTIMPL;
	}
	
	int GetWindow(out wireHWND phwnd)
	{
		try
		{
			logger.info("GetWindow");
			//logger.info("Window Location: " ~ toolbar.widget.oleFrame.getLocation().toString());
			phwnd = null;
		}
		catch(Exception ex)
		{
			logger.error(ex.toString);
			throw ex;
		}
		return S_OK;
	}
	
	int ContextSensitiveHelp(int fEnterMode)
	{
		logger.info("ContextSensitiveHelp");
		return E_NOTIMPL;
	}
	

}

extern(Windows) int DllUnregisterServer()
{
	return UnregisterServer!(IEToolbar)(); 	
}

extern(Windows) int DllGetClassObject(ref Guid rclsid, ref Guid riid, void** ppv)
{
	return GetClassObject!(IEToolbar)(rclsid, riid, ppv); 	
}

extern(Windows) int DllRegisterServer()
{
	return RegisterServer!(IEToolbar)(); 	
}

